/*
 *  Copyright (c) 2017, Facebook, Inc.
 *  All rights reserved.
 *
 *  This source code is licensed under the BSD-style license found in the
 *  LICENSE file in the root directory of this source tree. An additional grant
 *  of patent rights can be found in the PATENTS file in the same directory.
 *
 */

/*
 *  THIS FILE IS AUTOGENERATED. DO NOT MODIFY IT; ALL CHANGES WILL BE LOST IN
 *  VAIN.
 *
 */
#pragma once

#include <array>

#include <folly/Range.h>
#include <folly/dynamic.h>

namespace carbon {
namespace test {

struct CarbonTestRouterStatsConfig {
  static constexpr size_t kNumRequestGroups = 4;
  static constexpr std::array<folly::StringPiece, 1 * kNumRequestGroups>
      sumStatNames{{folly::StringPiece("cmd_AnotherRequest_count"),
                    folly::StringPiece("cmd_TestRequest_count"),
                    folly::StringPiece("cmd_TestRequestStringKey_count"),
                    folly::StringPiece("cmd_YetAnotherRequest_count")}};
  static constexpr std::array<folly::StringPiece, 3 * kNumRequestGroups>
      rateStatNames{{folly::StringPiece("cmd_AnotherRequest"),
                     folly::StringPiece("cmd_TestRequest"),
                     folly::StringPiece("cmd_TestRequestStringKey"),
                     folly::StringPiece("cmd_YetAnotherRequest"),
                     folly::StringPiece("cmd_AnotherRequest_out"),
                     folly::StringPiece("cmd_TestRequest_out"),
                     folly::StringPiece("cmd_TestRequestStringKey_out"),
                     folly::StringPiece("cmd_YetAnotherRequest_out"),
                     folly::StringPiece("cmd_AnotherRequest_out_all"),
                     folly::StringPiece("cmd_TestRequest_out_all"),
                     folly::StringPiece("cmd_TestRequestStringKey_out_all"),
                     folly::StringPiece("cmd_YetAnotherRequest_out_all")}};

  template <class Request>
  static constexpr size_t getStatGroup();
};

template <>
inline constexpr size_t
CarbonTestRouterStatsConfig::getStatGroup<AnotherRequest>() {
  return 0; // stat group 'AnotherRequest'
}

template <>
inline constexpr size_t
CarbonTestRouterStatsConfig::getStatGroup<TestRequest>() {
  return 1; // stat group 'TestRequest'
}

template <>
inline constexpr size_t
CarbonTestRouterStatsConfig::getStatGroup<TestRequestStringKey>() {
  return 2; // stat group 'TestRequestStringKey'
}

template <>
inline constexpr size_t
CarbonTestRouterStatsConfig::getStatGroup<test2::util::YetAnotherRequest>() {
  return 3; // stat group 'YetAnotherRequest'
}

} // test
} // carbon
